package lab_test;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

public class labyrinth {
	
	public char [] [] labField;
	
	labyrinth(String path) throws FileNotFoundException { // Konstruktor
		
		labField = readToCharArray(path);		
		
	}
	
	public String toString() { // ToString = Labyrinth ausdrucken
		
		String string = "";
		
		for (int i = 0; i<labField.length; i++) { // nochmal Zeile und Spalte durchgehen und zu String konvertieren
			
			for (int k = 0; k<labField[i].length; k++) {
				string += labField[i][k];
			}
			string += System.getProperty("line.separator"); // Zeilenumbruch
		}
		
		return string;
		
	}
	
	public static char [] [] readToCharArray(String path) throws FileNotFoundException { // Einlese-Methode
		
		Scanner scanner = new Scanner(new File(path));
		
		// AUSMESSEN DIMENSIONEN
		
		int width = 0;
		int height = 0;

		ArrayList<String> labFile = new ArrayList<>();
		
		while (scanner.hasNext()) {	// Einlesen der Zeilen in ArrayList;
			
			labFile.add(scanner.nextLine());
	
		}
		
		height = labFile.size();	// Hhe = Gre des ArraLists
	
		width = labFile.get(0).length(); // Breite = Lnge erster ArrayList-Eintrag
		
		scanner.close();
		
		System.out.printf("Labyrinth '%s' eingelesen. Hhe: %d, Breite: %d\n", path, height, width);
		
		// EINLESEN IN CHAR ARRAY
		
		char labChar [] [] = new char [height][width];
		
		for (int i = 0; i < height; i++) { // Von ArrayList zu CharArray konvertieren
			
			for (int k = 0; k < width; k++) {
				
				labChar [i] [k] = labFile.get(i).charAt(k); // i = Zeile, k = Spalte
				
			}
			
		}
	
		return labChar;
		
	}

}
